package com.zhiqiyun.open.mvc.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zhiqiyun.open.annotation.Permission;
import com.zhiqiyun.open.core.models.bz.BaseDataInfo;
import com.zhiqiyun.open.core.models.bz.SceneryInfo;
import com.zhiqiyun.open.core.models.user.OauthInfo;
import com.zhiqiyun.open.core.service.OauthService;
import com.zhiqiyun.open.core.service.SceneryInfoService;
import com.zhiqiyun.open.core.service.SequenceService;
import com.zhiqiyun.open.mvc.Result;
import com.zhiqiyun.open.mvc.params.bz.QuerySceneryInfoParams;
import com.zhiqiyun.open.mvc.params.bz.SaveSceneryInfoParams;
import com.zhiqiyun.open.utils.DateUtil;
import com.zhiqiyun.open.utils.ServletContext;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;
import java.util.List;

@RestController
@RequestMapping("/bz/base/scenery")
public class SceneryInfoController {

    @Autowired
    private SceneryInfoService sceneryInfoService;

    @Autowired
    private SequenceService sequenceService;

    @Autowired
    private OauthService oauthService;

    @Permission(value = "bz.base.scenery.find", tags = "查询景区")
    @PostMapping("/findPage")
    public Result findPage(@RequestBody QuerySceneryInfoParams params) {

        QueryWrapper<SceneryInfo> queryWrapper = new QueryWrapper<>();

        if (params.getGrade() != null) {
            queryWrapper.eq("grade", params.getGrade());
        }
        if (StringUtils.isNotBlank(params.getKeyword())) {
            StringBuilder sb = new StringBuilder("select id from bz_base_info where");
            sb.append(" name like ").append("'%").append(params.getKeyword()).append("%'");
            sb.append(" or brief like ").append("'%").append(params.getKeyword()).append("%'");
            sb.append(" or address like ").append("'%").append(params.getKeyword()).append("%'");
            sb.append(" or contacts like ").append("'%").append(params.getKeyword()).append("%'");
            sb.append(" or contact_number like ").append("'%").append(params.getKeyword()).append("%'");
            queryWrapper.inSql("id", sb.toString());
        }

        Page<SceneryInfo> page = params.getPage();
        page.addOrder(OrderItem.desc("id"));

        Page<SceneryInfo> resultData = this.sceneryInfoService.page(page, queryWrapper);

        return Result.instance(Result.Code.SUCCESS).setData(resultData);
    }

    @Permission(value = "bz.base.scenery.add", tags = "保存景区")
    @PostMapping("/save")
    public Result save(@Valid @RequestBody SaveSceneryInfoParams params) {

        this.sceneryInfoService.save(this.buildEntity(this.sequenceService.nextId(), params));

        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }

    @Permission(value = "bz.base.scenery.edit", tags = "编辑景区")
    @PostMapping("/updateById")
    public Result updateById(Long id, @RequestBody SaveSceneryInfoParams params) {

        this.sceneryInfoService.updateById(this.buildEntity(id, params));

        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }

    private SceneryInfo buildEntity(Long id, @Valid SaveSceneryInfoParams params) {

        SceneryInfo entity = new SceneryInfo();
        BaseDataInfo baseDataInfo = new BaseDataInfo();

        BeanUtils.copyProperties(params, entity);
        BeanUtils.copyProperties(params.getBaseDataInfo(), baseDataInfo);


        OauthInfo oauthInfo = this.oauthService.getAuth(ServletContext.getAccessToken());

        baseDataInfo.setCreatedTime(DateUtil.current());
        baseDataInfo.setUpdatedTime(DateUtil.current());
        baseDataInfo.setCreatedBy(oauthInfo.getId());
        baseDataInfo.setUpdatedBy(oauthInfo.getId());

        entity.setBaseDataInfo(baseDataInfo);
        entity.setId(id);
        return entity;
    }

    @Permission(value = "bz.base.scenery.delete", tags = "删除景区")
    @PostMapping("/deleteByIds")
    public Result deleteByIds(@RequestBody List<Long> ids) {
        this.sceneryInfoService.removeByIds(ids);
        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }
}
